### Nested Logit model estimation

### Create the data array from the existing dataset
Data <- read.csv("C:/Users/huang/Desktop/Summer school/Document/data.csv",header=T)
## Count the number of data rows
hh <- nrow(Data)

## Set the initial values of the parameters (the number in parenthesis corresponds to the number of parameters to be estimated)
b0 <- numeric(15) 

#Data$Age <- as.numeric(Data[2])
#Data$Male <- as.numeric(Data[3])
#Data$FareTrain <- as.numeric(Data[11])

##### Define the log-likelihood function of the logit model#####

fr <- function(x) {
  ### declare the parameters###
  ## Alternative specific constants
  b1 <- x[1]
  b2 <- x[2]
  b3 <- x[3]
  b4 <- x[4]
  
  ## Travel time to destination
  d1 <- x[5]
  
  ## Fare
  #d2 <- x[6]
  #d3 <- x[6]
  
  #a1 <- x[8]
  a2 <- x[6]
  #a3 <- x[10]
  a4 <- x[7]
  
  #g1 <- x[12]
  g2 <- x[8]
  #g3 <- x[14]
  #g4 <- x[15]
  
  #de1 <- x[10]
  #de2 <- x[11]
  #de3 <- x[12]
  de4 <- x[9]
  
  w1 <- x[10]
  w2 <- x[11]
  #w3 <- x[22]
  #w4 <- x[23]
  
  p1 <- x[12]
  #p2 <- x[25]
  #p3 <- x[26]
  p4 <- x[13]
  
  #wd1 <- x[14]
  #wd2 <- x[14]
  wd3 <- x[14]
  #wd4 <- x[17]
  
  
  
  ##Scale parameter
  pa1 <- x[15] 
  
  #pa2 <- 1
  
  
  ## declare the log-likelihood variable, set value to 0
  LL = 0
  
  ### For this choice problem, we consider the following 5 modes
  ## ??(train)  - (public)
  ## バス(bus)    - (public)
  ## 自動?(car)  - (private)
  ## 自転?(bike) - (private)
  ## 徒歩(walk)   - (private)
  
  ## calculate the utility function: :introduce the desired explanatory variables in the function
  # time           # fare      # constant
  #+ d2 * Data$FareTrain/100
  # + d2 * Data$FareBus/100
  # + a1 * Data$Age
  # + a3 * Data$Age
  # + g1 * Data$Male
  #+ g3 * Data$Male
  # + g4 * Data$Male
  # + w3*Data$Weekdays
  # + w4*Data$Weekdays
  # + p2*Data$Peak
  # + p3*Data$Peak
  
  #  + de2*Data$DepartureTime
  #  + de3 * Data$DepartureTime
  
  #  + de1 * Data$DepartureTime
  #  + d3 * Data$DistanceBus/10
  # + d3 * Data$DistanceCar/10000
  # + d3 * Data$DistanceBike/10000
  # + d3 * Data$DistanceWalk/10000
  # + wd1*Data$WorkDummy
  # + wd2*Data$WorkDummy
  # + wd4*Data$WorkDummy
  train  <- Data$ModeAvailableTrain*exp(d1  * Data$TotalTimeTrain/60 + w1*Data$Weekdays + p1*Data$Peak +b1*matrix(1,nrow =hh,ncol=1))
  bus    <- Data$ModeAvailableBus  *exp(d1 * Data$TotalTimeBus/60 + a2 * Data$Age + g2 * Data$Male + w2*Data$Weekdays    +b2*matrix(1,nrow =hh,ncol=1))
  car    <- Data$ModeAvailableCar  *exp(d1 * Data$TimeCar/60 + wd3*Data$WorkDummy         +b3*matrix(1,nrow =hh,ncol=1))
  bike   <- Data$ModeAvailableBike *exp(d1 * Data$TimeBike/60 + a4 * Data$Age  + de4 * Data$DepartureTime + p4*Data$Peak      +b4*matrix(1,nrow =hh,ncol=1))
  walk   <- Data$ModeAvailableWalk *exp(d1 * Data$TimeWalk/60)
  
  ### Construct nests.First, calculate public or private choice probabilityP(LV1)
  ## setting of log-sum variables
  logsum.motorized  <- log( ( (train + bus + car)!=0) * (train + bus + car) + ((train + bus + car)==0))
  logsum.private <- log( ( ( bike + walk)!=0) * (bike + walk) + ((bike + walk)==0))
  
  ##Calculate public or private choice probability with these log-sum variables
  nume.motorized   <- (logsum.motorized != 0)*exp(pa1*logsum.motorized) + (logsum.motorized == 0)
  nume.private  <- (logsum.private != 0)*exp(pa1*logsum.private) + (logsum.private == 0)
  
  deno <- nume.motorized + nume.private
  #deno <- nume.motorized + bike + walk
  P.motorized  <- nume.motorized  / deno
  P.private <- nume.private / deno
  #Pcar <- Data$ModeAvailableCar * (car / deno)
  #Pbike <- Data$ModeAvailableBike * (bike / deno)
  #Pwalk <- Data$ModeAvailableWalk * (walk / deno)
  
  
  
  ### Next, calculate conditional probability.P(LV2|LV1)
  ## conditional probability under public choice
  deno.motorized     <- train + bus + car
  P.train.motorized  <- train / ((deno.motorized!=0)*deno.motorized + (deno.motorized==0))
  P.bus.motorized    <- bus   / ((deno.motorized!=0)*deno.motorized + (deno.motorized==0))
  P.car.motorized    <- car   / ((deno.motorized!=0)*deno.motorized + (deno.motorized==0))
  
  ## conditional probability under private choice
  deno.private    <- bike + walk
  #P.car.private   <- car   / ((deno.private!=0)*deno.private + (deno.private==0))
  P.bike.private  <- bike  / ((deno.private!=0)*deno.private + (deno.private==0))
  P.walk.private  <- walk  / ((deno.private!=0)*deno.private + (deno.private==0))
  
  ### Finally, calculate joint probability. P(LV1, LV2) = P(LV2|LV1)*P(LV1)
  P.train <- P.train.motorized * P.motorized
  P.bus   <- P.bus.motorized   * P.motorized
  P.car   <- P.car.motorized  * P.motorized
  P.bike  <- P.bike.private * P.private
  P.walk  <- P.walk.private * P.private
  
  ## Avoid problems stemming from choice probabilities becoming zero.
  P.train <- (P.train!=0)*P.train + (P.train==0)
  P.bus   <- (P.bus!=0)  *P.bus   + (P.bus==0)
  P.car   <- (P.car!=0)  *P.car   + (P.car==0)
  P.bike  <- (P.bike!=0) *P.bike  + (P.bike==0)
  P.walk  <- (P.walk!=0) *P.walk  + (P.walk==0)
  #Pbike <- (Pbike !=0) * Pbike + (Pbike == 0)
  #Pwalk   <- (Pwalk !=0) * Pwalk     + (Pwalk == 0)
  #Pcar   <- (Pcar !=0) * Pcar   + (Pcar == 0)
  
  ## Choice results
  C.train   <- Data$MainModeENG =="Rail"
  C.bus     <- Data$MainModeENG =="Bus"
  C.car     <- Data$MainModeENG =="Car"
  C.bike    <- Data$MainModeENG =="Bicycle"
  C.walk    <- Data$MainModeENG =="Walk"
  
  ## Calculate the Log-likelihood function
  LL <- colSums(C.train*log(P.train) + C.bus*log(P.bus) + C.car  *log(P.car) + C.bike*log(P.bike) + C.walk *log(P.walk))
  
}

##### Maximize the Log-likelihood function#####

##Parameter optimization 
res <- optim(b0,fr, method = "BFGS", hessian = TRUE, control=list(fnscale=-1))

## Parmeter estimation、Hessian matrix calculation 
b   <- res$par
hhh <- res$hessian

## Calculate the t-statistic
tval <- b/sqrt(-diag(solve(hhh)))

## L(0), Log-Likelihood when all parameters are 0
L0 <- fr(b0)
## LL, maximium likelihood
LL <- res$value

##### Output #####
print(res)
## L(0)
print(L0)
## LL
print(LL)
##rho-square
print((L0-LL)/L0)
## adjusted rho-square
print((L0-(LL-length(b)))/L0)
##estimated parameter values
print(b)
## t-statistic 
print(tval)
